---
title: DataTransfer.files
slug: Web/API/DataTransfer/files
tags:
  - API
  - HTML DOM
  - Property
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DataTransfer.files</code></strong> property is a {{domxref("FileList","list of the files")}} in the drag operation. If the operation includes no files, the list is empty.</p>

<p>This feature can be used to drag files from a user's <em>desktop</em> to the browser.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>dataTransfer</var>.files;
</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("FileList","list")}} of the files in a drag operation, one list item for each file in the operation. If the drag operation had no files, the list is empty.</p>

<h2 id="Example">Example</h2>

<p>There are two live examples of this interface:</p>

<ul>
 <li>Firefox only: <a class="external" href="http://jsfiddle.net/9C2EF/">http://jsfiddle.net/9C2EF/</a></li>
 <li>All browsers: <a class="external" href="https://jsbin.com/hiqasek/edit?html,js,output">https://jsbin.com/hiqasek/</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "interaction.html#dom-datatransfer-files", "files")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "editing.html#dom-datatransfer-files", "files")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.files")}}</p>
